
USE SVH_REPORT_DB
GO

/*
|| Autor: Jhon Reyes
|| Fecha: 2022.04.07
|| Proyecto: JUNO
|| Proceso: Crea tabla en la DDBB REPORT. 
||				Se crea a partir de los datos historico de UR_MAESTRO. 
||				Esta tabla se consultará en varios procesos de la creación de los datamarts			
*/

/*
|| MODELO JUNO
|| Granularidad: SOCIEDAD + UR
*/


/*
|| Autor: Jhon Reyes
|| Fecha: 2022.03.22
|| Proceso: Contiene la data a cierre de mes
*/

DECLARE @FECHA_FIN_DATOS VARCHAR(10); 
SET @FECHA_FIN_DATOS = CONVERT(VARCHAR(10),DATEADD(DD,-(DAY(GETDATE())),GETDATE()),121);	
--SET @FECHA_FIN_DATOS = CAST(GETDATE()-1 AS DATE);

DECLARE @PERIODO_DATAMART VARCHAR(6);
SET @PERIODO_DATAMART = CONVERT(VARCHAR(6),DATEADD(dd,-(DAY(GETDATE())),GETDATE()),112);

DECLARE @FECHA_VENTA VARCHAR(10), @FECHA_REGISTRO_BAJA VARCHAR(10); 
SET @FECHA_VENTA = '2022-05-01';	
SET @FECHA_REGISTRO_BAJA = '2022-05-01';

--==========================================================================
--						Temporal Sociedades							
--==========================================================================

DROP TABLE IF EXISTS #TMP_SOCIEDADES

SELECT CAMPO, 
		 VALOR AS SOCIEDAD
  INTO #TMP_SOCIEDADES
  FROM [JUNO].[TMP_PARAMETRICA]
WHERE INFORME = 'SOCIEDAD'
  AND CONCEPTO IN('KUTXABANK. PERIMETRO BANCOS', 'KUTXABANK. PERIMETRO INMOBILIARIA')
  AND FLAG = 1


DROP TABLE IF EXISTS #TMP_SOCIEDADES_BANCOS

SELECT CAMPO, 
		 VALOR AS SOCIEDAD
  INTO #TMP_SOCIEDADES_BANCOS
  FROM [JUNO].[TMP_PARAMETRICA]
WHERE INFORME = 'SOCIEDAD'
  AND CONCEPTO = 'KUTXABANK. PERIMETRO BANCOS'
  AND FLAG = 1

--==========================================================================
--								Excluir URs Dummies 											 
--==========================================================================
/*
|| Fecha: 2022.09.13
|| Autor: Jhon Reyes
|| Proceso: Excluir URs del perimetro de cartera
|| Detalle:
||		- Antes: Se hardcodeaban las URs y se guardaban en una variable de tabla
||		- Ahora: Previamente se creado y cargado una tabla, que contiene todas las URs a excluir del perimetro de cartera.
*/  
	DROP TABLE IF EXISTS #TMP_URS_DUMMIES
	SELECT
		SOCIEDAD,
		UNIDAD_REGISTRAL 
		INTO #TMP_URS_DUMMIES 
	FROM [JUNO].[TMP_MODIFICACION_PERIMETRO_CIERRE] 
	WHERE
		CONTROL_PERIMETRO = 'EXCLUIR URS' 
		AND IND_EJECUCION = 'X' 
		AND PERIODO_CIERRE = @PERIODO_DATAMART
 
 
--===========================================================================
--						Incluir URs Vendidas en Abril	
-- Ventas del mes de abril, gestionadas por SVH. Siempre se deben de incluir.					 
--===========================================================================

/*
|| Fecha: 2022.09.13
|| Autor: Jhon Reyes
|| Proceso: Incluir URs al perimetro de cartera
|| Detalle:
||		- Antes: Se hardcodeaban las URs y se guardaban en una variable de tabla
||		- Ahora: Previamente se creado y cargado una tabla, que contiene todas las URs a incluir en el perimetro de cartera.
*/

	DROP TABLE IF EXISTS #TMP_URS_VENTAS_ABRIL
	SELECT
		SOCIEDAD,
		UNIDAD_REGISTRAL 
		INTO #TMP_URS_VENTAS_ABRIL 
	FROM [JUNO].[TMP_MODIFICACION_PERIMETRO_CIERRE] 
	WHERE
		CONTROL_PERIMETRO = 'INCLUIR URS' 
		AND IND_EJECUCION = 'X' 
		AND PERIODO_CIERRE = @PERIODO_DATAMART


--=========================================================================================================================================
--														    HISTORICO UR MAESTRO. TABLA TEMPORAL - GRANULARIDAD SOCIEDAD + UR
--=========================================================================================================================================


--==========================================================================
--						Temporal SOLO Stock de Sociedades Bancos							 
--==========================================================================


DROP TABLE IF EXISTS #TMP_UR_MAESTRO_HIST_STOCK_BANCOS

SELECT
	  UR.SOCIEDAD
	, UR.UNIDAD_REGISTRAL
	, UR.PROMOCION_COMERCIAL
	, UR.PROMOCION_CONJUNTA
	, UR.FECHA_TITULO
	, UR.FECHA_ESCRITURA_ALTA
	, UR.DESC_SOCIEDAD
	, CASE WHEN ISNULL(UR.FECHA_TITULO, '') = '' THEN UR.FECHA_ESCRITURA_ALTA ELSE UR.FECHA_TITULO END FECHA_ADJUDICACION
	, UR.PAIS 
	, UR.PROVINCIA 
	, UR.DESC_PROVINCIA
	, UR.CM_FISCAL 
	, UR.DESC_CM_FISCAL
	, UR.DESC_POBLACION 
	, UR.TIPO_VIA
	, UR.CALLE 
	, UR.NUMERO 
	, UR.BLOQUE 
	, UR.PISO 
	, UR.PUERTA
	, UR.COD_POSTAL 
	, UR.IDUFIR 
	, UR.PROVINCIA_REGISTRO 
	, UR.DESC_PROVINCIA_REGISTRO
	, UR.MUNICIPIO_REGISTRO 
	, UR.DESC_MUNICIPIO_REGISTRO
	, UR.NUM_REGISTRO 
	, UR.NUM_TOMO 
	, UR.NUM_LIBRO 
	, UR.FINCA 
	, UR.TIPO_INMUEBLE
	, UR.MODO
	, UR.DESC_TIPO_INMUEBLE
	, UR.PARALIZACION_URBANIZACION
	, UR.NUM_AUTOS 
	, UR.FECHA_POSESION
	, CASE WHEN ISNULL(UR.FECHA_POSESION, '') = '' THEN UR.FECHA_TITULO ELSE UR.FECHA_POSESION END FECHA_POSESION_RPT
	, UR.EXPEDIENTE
	, UR.CONTRATO
	, UR.CENTRO
	, UR.FECHA_REGISTRO_BAJA
	, UR.FECHA_VENTA 
	, UR.DESC_UR 
	, UR.SOCIEDAD_ORIGEN 
	, UR.FECHA_SELLO 	
	, UR.IND_STK_NEG
	, UR.IND_VENTA_REALIZADA
	, UR.IND_BAJA_REALIZADA		
	, CASE
		WHEN UR.COEFICIENTE_INDIVISA = 100 THEN 100 
		WHEN UR.COEFICIENTE_INDIVISA = 0 THEN 100
		WHEN UR.COEFICIENTE_INDIVISA IS NULL THEN 100
		ELSE 100 - UR.COEFICIENTE_INDIVISA 
	 END COEFICIENTE_INDIVISA 
	, UR.FINCA_DRM
	, UR.DESC_PROMOCION_COMERCIAL
	, UR.DESC_PROMOCION_CONJUNTA
	, UR.PRODUCTO
	, UR.DESC_PRODUCTO
	, UR.TIPO_COMERCIALIZACION
	, UR.DESC_TIPO_COMERCIALIZACION
	, UR.CODIGO_ACTUACION_ALTA
	, UR.DESC_CODIGO_ACTUACION_ALTA
	, UR.CODIGO_ACTUACION_BAJA	
	, UR.DESC_CODIGO_ACTUACION_BAJA
	, UR.FECHA_REGISTRO_ALTA
	, '01' IND_CONTROL_CARTERA		
	, 'STOCK' CONTROL_CARTERA
	, 'STOCK BANCOS - TABLA UR_PERIMETRO_CIERRE' ORIGEN_PERIMETRO
	, DATA_ADHOC.USR061 ADHOC_USR061
	, DATA_ADHOC.USR001 ADHOC_USR001
	, CASE WHEN DATA_ADHOC.SOCIEDAD IS NOT NULL THEN 'X' ELSE '' END IND_DATA_ADHOC
	, 'X' IND_MIGRACION
	, 'MIGRACION NORMAL' DETALLE_MIGRACION
	, CAST(GETDATE() AS DATE) FECHA_CARGA
	, UR.FECHA_DATOS
   , CASE WHEN CODIGO_ACTUACION_BAJA = 'BCGR' THEN 'X' ELSE '' END AS IND_APORTACION

  INTO #TMP_UR_MAESTRO_HIST_STOCK_BANCOS  
FROM [SVH_CORP_DB].[HISTORICO].[UR_MAESTRO] UR
INNER JOIN #TMP_SOCIEDADES_BANCOS SOCIEDADES ON UR.SOCIEDAD = SOCIEDADES.SOCIEDAD
INNER JOIN [SVH_CORP_DB].[dbo].[UR_PERIMETRO_CIERRE] PERIMETRO ON UR.SOCIEDAD = PERIMETRO.SOCIEDAD AND UR.UNIDAD_REGISTRAL = PERIMETRO.UNIDAD_REGISTRAL
LEFT JOIN [JUNO].[TMP_URS_DATA_ADHOC] DATA_ADHOC ON UR.SOCIEDAD = DATA_ADHOC.SOCIEDAD AND UR.UNIDAD_REGISTRAL = DATA_ADHOC.UNIDAD_REGISTRAL
WHERE UR.FECHA_DATOS = @FECHA_FIN_DATOS
AND PERIMETRO.IND_STK_NEG IN ('X', 'Y')
AND PERIMETRO.ANYO_MES = @PERIODO_DATAMART


--==========================================================================
--			Temporal con el perimetro del historico de UR_MAESTRO. 
--			Se excluyen las URs de Stock Bancos (proceso anterior)
--==========================================================================

DROP TABLE IF EXISTS #TMP_UR_MAESTRO_HIST_PRE

SELECT
	  UR.SOCIEDAD
	, UR.UNIDAD_REGISTRAL
	, UR.PROMOCION_COMERCIAL
	, UR.PROMOCION_CONJUNTA
	, UR.FECHA_TITULO
	, UR.FECHA_ESCRITURA_ALTA
	, UR.DESC_SOCIEDAD
	, CASE WHEN ISNULL(UR.FECHA_TITULO, '') = '' THEN UR.FECHA_ESCRITURA_ALTA ELSE UR.FECHA_TITULO END FECHA_ADJUDICACION
	, UR.PAIS 
	, UR.PROVINCIA 
	, UR.DESC_PROVINCIA
	, UR.CM_FISCAL 
	, UR.DESC_CM_FISCAL
	, UR.DESC_POBLACION 
	, UR.TIPO_VIA
	, UR.CALLE 
	, UR.NUMERO 
	, UR.BLOQUE 
	, UR.PISO 
	, UR.PUERTA
	, UR.COD_POSTAL 
	, UR.IDUFIR 
	, UR.PROVINCIA_REGISTRO 
	, UR.DESC_PROVINCIA_REGISTRO
	, UR.MUNICIPIO_REGISTRO 
	, UR.DESC_MUNICIPIO_REGISTRO
	, UR.NUM_REGISTRO 
	, UR.NUM_TOMO 
	, UR.NUM_LIBRO 
	, UR.FINCA 
	, UR.TIPO_INMUEBLE
	, UR.MODO
	, UR.DESC_TIPO_INMUEBLE
	, UR.PARALIZACION_URBANIZACION
	, UR.NUM_AUTOS 
	, UR.FECHA_POSESION
	, CASE WHEN ISNULL(UR.FECHA_POSESION, '') = '' THEN UR.FECHA_TITULO ELSE UR.FECHA_POSESION END FECHA_POSESION_RPT
	, UR.EXPEDIENTE
	, UR.CONTRATO
	, UR.CENTRO
	, UR.FECHA_REGISTRO_BAJA
	, UR.FECHA_VENTA 
	, UR.DESC_UR 
	, UR.SOCIEDAD_ORIGEN 
	, UR.FECHA_SELLO 	
	, UR.IND_STK_NEG
	, UR.IND_VENTA_REALIZADA
	, UR.IND_BAJA_REALIZADA		
	, CASE
		WHEN UR.COEFICIENTE_INDIVISA = 100 THEN 100 
		WHEN UR.COEFICIENTE_INDIVISA = 0 THEN 100
		WHEN UR.COEFICIENTE_INDIVISA IS NULL THEN 100
		ELSE 100 - UR.COEFICIENTE_INDIVISA 
	 END COEFICIENTE_INDIVISA 
	, UR.FINCA_DRM
	, UR.DESC_PROMOCION_COMERCIAL
	, UR.DESC_PROMOCION_CONJUNTA
	, UR.PRODUCTO
	, UR.DESC_PRODUCTO
	, UR.TIPO_COMERCIALIZACION
	, UR.DESC_TIPO_COMERCIALIZACION
	, UR.CODIGO_ACTUACION_ALTA
	, UR.DESC_CODIGO_ACTUACION_ALTA
	, UR.CODIGO_ACTUACION_BAJA	
	, UR.DESC_CODIGO_ACTUACION_BAJA
	, UR.FECHA_REGISTRO_ALTA
	, CASE 
		WHEN UR.IND_STK_NEG IN ('X', 'Y') AND UR.IND_VENTA_REALIZADA = 'X' THEN 'E02'
		WHEN UR.IND_STK_NEG IN ('X', 'Y') AND UR.IND_BAJA_REALIZADA = 'X' THEN 'E03'
		WHEN UR.IND_STK_NEG IN ('X', 'Y') THEN '01'
		WHEN UR.IND_VENTA_REALIZADA = 'X' THEN '02'
		WHEN UR.IND_BAJA_REALIZADA = 'X' THEN '03'
		ELSE 'E99'
	  END IND_CONTROL_CARTERA		
	, CASE 
		WHEN UR.IND_STK_NEG IN ('X', 'Y') THEN 'STOCK'
		WHEN UR.IND_VENTA_REALIZADA = 'X' THEN 'VENTA'
		WHEN  UR.IND_BAJA_REALIZADA = 'X' THEN 'BAJA'
		ELSE 'ERROR. DESCONOCIDO'
	  END CONTROL_CARTERA
	, 'PERIMETRO CARTERA - TABLA HISTORICO.UR_MAESTRO' ORIGEN_PERIMETRO
	, DATA_ADHOC.USR061 ADHOC_USR061
	, DATA_ADHOC.USR001 ADHOC_USR001	
	, CASE WHEN DATA_ADHOC.SOCIEDAD IS NOT NULL THEN 'X' ELSE '' END IND_DATA_ADHOC
	, 'X' IND_MIGRACION
	, 'MIGRACION NORMAL' DETALLE_MIGRACION	
	, CAST(GETDATE() AS DATE) FECHA_CARGA
	, UR.FECHA_DATOS
   , CASE WHEN UR.CODIGO_ACTUACION_BAJA = 'BCGR' THEN 'X' ELSE '' END IND_APORTACION
	
  INTO #TMP_UR_MAESTRO_HIST_PRE  
FROM [SVH_CORP_DB].[HISTORICO].[UR_MAESTRO] UR
INNER JOIN #TMP_SOCIEDADES SOCIEDADES ON UR.SOCIEDAD = SOCIEDADES.SOCIEDAD
LEFT JOIN #TMP_URS_DUMMIES DUMMY ON UR.SOCIEDAD = DUMMY.SOCIEDAD AND UR.UNIDAD_REGISTRAL = DUMMY.UNIDAD_REGISTRAL
LEFT JOIN [JUNO].[TMP_URS_DATA_ADHOC] DATA_ADHOC ON UR.SOCIEDAD = DATA_ADHOC.SOCIEDAD AND UR.UNIDAD_REGISTRAL = DATA_ADHOC.UNIDAD_REGISTRAL
LEFT JOIN [JUNO].[TMP_APORTACION_URS] APORTACION ON UR.SOCIEDAD = APORTACION.SOCIEDAD AND UR.UNIDAD_REGISTRAL = APORTACION.UNIDAD_REGISTRAL
WHERE UR.FECHA_DATOS = @FECHA_FIN_DATOS
AND(
		(UR.IND_STK_NEG IN('X', 'Y')) 
		OR (UR.IND_VENTA_REALIZADA = 'X' AND UR.FECHA_VENTA >= @FECHA_VENTA)
		OR (UR.IND_BAJA_REALIZADA = 'X' AND UR.FECHA_REGISTRO_BAJA >= @FECHA_REGISTRO_BAJA)
		OR EXISTS(SELECT 'X' FROM #TMP_URS_VENTAS_ABRIL VTA WHERE UR.SOCIEDAD = VTA.SOCIEDAD AND UR.UNIDAD_REGISTRAL = VTA.UNIDAD_REGISTRAL)
	)	
AND DUMMY.SOCIEDAD IS NULL
AND NOT EXISTS (SELECT 'X' FROM #TMP_UR_MAESTRO_HIST_STOCK_BANCOS STOCK_BANCOS WHERE UR.SOCIEDAD = STOCK_BANCOS.SOCIEDAD AND UR.UNIDAD_REGISTRAL = STOCK_BANCOS.UNIDAD_REGISTRAL)


--==========================================================================
--	  Tabla Final TMP_UR_MAESTRO_HIST. Temporal con el perimetro de Cartera							 
--==========================================================================

TRUNCATE TABLE [JUNO].[TMP_UR_MAESTRO_HIST]

INSERT INTO [JUNO].[TMP_UR_MAESTRO_HIST]
SELECT Z.* 
FROM(
	SELECT * FROM #TMP_UR_MAESTRO_HIST_STOCK_BANCOS
	UNION ALL
	SELECT * FROM #TMP_UR_MAESTRO_HIST_PRE
	)Z
